_header(`Linux')
<UL>
<LI>_link(`How to Linux', `http://tldp.yolinux.com/HOWTO/subdir/HOWTO-INDEX.html')</LI>
<LI>_link(`How to Use User Mode Linux', `https://christine.website/blog/howto-usermode-linux-2019-07-07')</LI>
<LI><A HREF="https://www.cs.cmu.edu/~awb/linux.history.html">LINUX's History</A></LI>
<LI>_link(`The Linux Kernel documentation', `https://www.kernel.org/doc/html/v4.17/index.html')</LI>
<LI>_link(`LINUX is obsolete', `https://groups.google.com/g/comp.os.minix/c/wlhw16QWltI')</LI>
<LI>_link(`Linux From Scratch', `http://www.linuxfromscratch.org/')</LI>
<LI>_link(`Move your Linux from BIOS to UEFI in place', `https://www.redhat.com/sysadmin/bios-uefi')</LI>
<LI><A HREF="https://www.collabora.com/news-and-blog/blog/2020/08/27/using-the-linux-kernel-case-insensitive-feature-in-ext4/">Using the Linux kernel's Case-insensitive feature in Ext4</A></LI>
</UL>

<H3 ID="#Linux#ACPI">ACPI</H3>
_bibliography(`
_bentr(`_ref(`#ACPI')')
')
<P>
logind (as part of SystemD), elogind, acpid, and many desktop environments can manage ACPI events automatically, and sometimes this is configured by default as part of a Linux software distribution.
</P>
_subsubheader(`acpid(8)')
_bibliography(`
_bentr(`_link(`acpid', `https://sourceforge.net/projects/acpid2/')')
')
<P>
_man(`acpid(8)') is a daemon that can automatically manage ACPI events on Linux.
</P>

_subheader(`Audio')
<P>
Most audio servers recommend that they be run in userspace with user privileges, with PulseAudio going so far as to exiting when run as root without additional configuration.
The Alpine wiki currently recommends _man(`pipewire(1)'), with postmarketOS, which is based on Alpine, coming pre-configured with PipeWire.
PipeWire is relatively new and the typical audio server used is PulseAudio; Debian and many popular Debian-based distributions come pre-configured with PulseAudio.
</P>
_subsubheader(`ALSA')
<UL>
<LI><A HREF="https://wiki.alpinelinux.org/wiki/Main_Page/Adding_sound">Adding sound</A> (Alpine Linux Wiki)</LI>
<LI><A HREF="https://bbs.archlinux.org/viewtopic.php?id=256857">ALSA lib conf Evaluate error</A></LI>
<LI><A HREF="https://dev.to/setevoy/linux-alsa-lib-pcmdmixc1108sndpcmdmixopen-unable-to-open-slave-38on">ALSA lib pcm_dmix.c:1108:(snd_pcm_dmix_open) unable to open slave</A></LI>
</UL>
<P>
The Alpine wiki ("Adding sound") says to install _code(`alsa-conf'), _code(`alsa-lib'), and _code(`alsa-utils'),
add yourself to the _code(`audio') group, and then do some more configuration that I've never needed to do:
Use _man(`alsamixer(1)') to find a working sound card (press _code(`F6') from the first screen ALSAMixer presents)
and edit _code(`/usr/share/alsa/alsa.conf') and change _code(`defaults.ctl.card') and _code(`defaults.pcm.card') to the sound card that works.
</P>
<P>
The Alpine wiki doesn't mention this but you'll need to enable the _code(`alsa') OpenRC service and either start it or reboot.
I also installed _code(`gstreamer') but I don't know why.
</P>
<P>
ALSA is clunky, many people prefer to use a frontend such as Pipewire or PulseAudio that exposes its own interface while remaining compatible with ALSA.
</P>
<H4>OSS</H4>
<P>
Deprecated, unfortunately.
</P>
<H4>PipeWire</H4>
<UL>
<LI><A HREF="https://wiki.alpinelinux.org/wiki/PipeWire">PipeWire</A> (Alpine Linux Wiki)</LI>
<LI><A HREF="https://gitlab.freedesktop.org/pipewire/pipewire/-/wikis/home">PipeWire</A> (FreeDesktop Wiki)</LI>
</UL>
<P>
Provided by the _code(`pipewire') package on Alpine.
</P>
<PRE>
RTKit error: org.freedesktop.DBus.Error.ServiceUnknown
</PRE>
<P>
This means you need _code(`rtkit') installed and running through your initialization system.
</P>
<H4>PulseAudio</H4>
<P>
On Alpine you'll need the _code(`pulseaudio'), _code(`pulseaudio-alsa'), and _code(`alsa-plugins-pulse') packages for PulseAudio with ALSA compatibility.
Start _man(`pulseaudio(1)') when you want audio, ideally in your _code(`.xinitrc').
</P>

_subheader(`Distributions')
<P>
Linux is usually obtained as part of a software distribution put together to form a useable operating system.
</P>
<H4>Alpine</H4>
<UL>
<LI><A HREF="https://pkgs.alpinelinux.org/contents">Alpine repositories content search</A></LI>
</UL>
<H5>Always install manual pages</H5>
<P>
Alpine doesn't include man pages in program packages to save on space, instead keeping them in _code(`[<I>package</I>]-doc') sibling packages.
To always install doc packages with program packages, _code(`apk add docs').
</P>
<H4>Arch</H4>
<P>
Arch is known for using the latest versions of programs, which has given it an undeserved reputation of instability.
</P>
<H5>Bootstrapping</H5>
<P>
Use _man(`pacstrap(8)').
</P>
<P>
At a minimum you need the _code(`base') package.
Select a kernel and install the corresponding package; _code(`linux'), _code(`linux-lts'), or another Linux configuration or fork.
The Arch wiki says you need to install _code(`linux-firmware'), this isn't strictly necessary but it is recommended.
Install _code(`base-devel') if you plan on using the AUR or if you don't know what the AUR is yet.
</P>
<P>
It's also a good idea to install any utilities you'll need on the bootstrapped system.
Text editors, network managers or utilities, and other administration tools, for example.
Manual utilities such as _code(`man-db') and others would also be useful.
</P>
<H5>Ubiquitous packages missing</H5>
<P>From the annals of my notes, 2021-06-04:</P>
<PRE>
Had an issue with pacman missing some ubiquitous packages (esr's 'ascii', xorg-xev, etc).
This fixed it. I don't really know why - maybe some issues with my repos?
This was cleanly installed artix-openrc.

[5:46 PM] Bassman Leyla: So what I did is I went into /etc/pacman.d/mirrorlist-arch and uncommented a local mirror
[5:46 PM] Bassman Leyla: Then I appended a config block a package maintainer gave me onto /etc/pacman.conf
[5:46 PM] Bassman Leyla: I'll paste it in
[5:47 PM] Bassman Leyla:
'''
#
# ARCHLINUX
#

#[testing]
#Include = /etc/pacman.d/mirrorlist-arch

[extra]
Include = /etc/pacman.d/mirrorlist-arch

#[community-testing]
#Include = /etc/pacman.d/mirrorlist-arch

[community]
Include = /etc/pacman.d/mirrorlist-arch

#[multilib-testing]
#Include = /etc/pacman.d/mirrorlist-arch

#[multilib]
#Include = /etc/pacman.d/mirrorlist-arch
'''
</PRE>
<H4>Artix</H4>
<UL>
<LI><A HREF="https://artixlinux.org/">Artix Linux</A></LI>
<LI><A HREF="https://en.wikipedia.org/wiki/Artix_Linux">Artix Linux</A> (Wikipedia)</LI>
</UL>
<P>
Artix is a Linux software distribution based on Arch that doesn't mandate SystemD as its initialization system.
</P>
<H5>Bootstrapping</H5>
<P>
This process differs from Arch's bootstrapping process.
Artix uses _man(`basestrap(8)') rather than _man(`pacstrap(8)');
you need to select the initialization you want to use: _code(`66'), _code(`dinit'), _code(`openrc'), _code(`runit'), or _code(`s6-base'), as a package separate from _code(`base');
and Artix's official wiki says you need to install the appropriate _link(`#logind', `_code(`elogind')') package (_code(`elogind-[<I>initialization system</I>]') e.g. _code(`elogind-66')) but like _code(`linux-firmware') though it is helpful it isn't strictly necessary.
</P>

<H4>Debian</H4>
<UL>
<LI><A HREF="https://www.debian.org/">Debian</A></LI>
<LI><A HREF="https://en.wikipedia.org/wiki/Debian">Debian</A> (Wikipedia)</LI>
</UL>
<P>
Debian is known for its stability and longevity.
Debian uses SystemD as its initialization system, the GNU core utilities, and dpkg and apt for package management.
</P>
<P>
While it's possible to use non-Linux kernels within Debian, it's uncommon and the only non-Linux option currently maintained is the GNU HURD microkernel.
</P>

<H4>postmarketOS</H4>
<P>
postmarketOS is an Alpine-based Linux software distribution that makes configuring and using Linux easy on mobile devices.
</P>
<H5>Random MAC address generation on Wifi</H5>
<P>
By default, postmarketOS will generate a random software MAC address when connecting to a new WLAN network.
You can disable this by adding a NetworkManager rule.
In _code(`/etc/NetworkManager/conf.d/') you can make a file with any name that has the following:
</P>
<PRE>
[device]
wifi.scan-rand-mac-address=no
</PRE>
<P>
On a live system you can then _code(`rc-service networkmanager restart') to restart NetworkManager and have it load the new configuration.
</P>

<H4>Ubuntu</H4>
<UL>
<LI><A HREF="https://securitylab.github.com/research/Ubuntu-gdm3-accountsservice-LPE/">How to get root on Ubuntu 20.04 by pretending nobody's /home</A></LI>
</UL>
<P>
Ubuntu is a derivative of Debian.
</P>

_subheader(`logind')
<UL>
<LI><A HREF="https://github.com/elogind/elogind">elogind</A></LI>
<LI><A HREF="https://wiki.gentoo.org/wiki/Elogind">elogind</A> (Gentoo Wiki)</LI>
<LI><A HREF="https://www.freedesktop.org/software/systemd/man/org.freedesktop.login1.html">org.freedesktop.login1</A></LI>
<LI><A HREF="https://nixos.wiki/wiki/Logind">logind</A> (NixOS Wiki)</LI>
</UL>
<P>
logind (_code(`systemd-logind.service(8)')) is a component of SystemD that exposes information about active users on the system via the org.freedesktop.login1 D-Bus interface which is used by the popular desktop environments GNOME and KDE.
It also handles _ref(`#ACPI') events.
It can be configured in _code(`logind.conf(5)').
</P>
<P>
On systems without SystemD and with conflicting software, _code(`elogind(8)') may be used.
</P>

_subheader(`util-linux')
<UL>
<LI>_link(`util-linux', `https://en.wikipedia.org/wiki/Util-linux') (Wikipedia)</LI>
</UL>
<P>
_code(`util-linux') is distributed on all popular Linux distributions and contains utilities users may expect to be already present on their systems, like _man(`more(1)') or _man(`hexdump(1)').
</P>

_subheader(`Xenia')
_bibliography(`
_bentr(`_link(`A hacker fox!', `http://yerf.metafur.org/date/1996-07-14')')
')
<P>
Xenia was an entry for the Linux logo competition which Tux eventually won.
</P>
